------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--    O C A R I N A . C H E C K E R . Q U E R I E S . O P E R A T O R S     --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                 Copyright (C) 2007, GET-Telecom Paris.                   --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with Types;
with Ocarina.Entities.Properties;

package body Ocarina.Checker.Queries.Operators is
   use Types;
   use Ocarina.Entities.Properties;

   ----------
   -- Card --
   ----------

   function Card (Set : Result_Set) return Natural
   is
   begin
      return Natural (Set.Cardinal);
   end Card;

   ---------
   -- Sum --
   ---------

   function Sum
     (Set : Result_Set;
      Property_Name : String)
     return Integer
   is
      Val   : Node_Id;
      Sum_T : Integer := 0;
   begin
      for I in 1 .. Set.Cardinal loop
         Val := Get_Property_Value (Set.Elements (I), Property_Name);
         if Val = No_Node then
            raise Program_Error;
         end if;
         Sum_T := Sum_T + Integer (Get_Integer_Of_Property_Value (Val));
      end loop;

      return Sum_T;
   end Sum;

   ---------
   -- Sum --
   ---------

   function Sum
     (Set : Result_Set;
      Property_Name : String)
     return Float
   is
      Val   : Node_Id;
      Sum_T : Float := 0.0;
   begin
      for I in 1 .. Set.Cardinal loop
         Val := Get_Property_Value (Set.Elements (I), Property_Name);
         if Val = No_Node then
            raise Program_Error;
         end if;
         Sum_T := Sum_T + Float (Get_Float_Of_Property_Value (Val));
      end loop;

      return Sum_T;
   end Sum;

end Ocarina.Checker.Queries.Operators;
