------------------------------------------------------------------------------
--                                                                          --
--                           OCARINA COMPONENTS                             --
--                                                                          --
--                      O C A R I N A _ O P T I O N S                       --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--               Copyright (C) 2006-2007, GET-Telecom Paris.                --
--                                                                          --
-- Ocarina  is free software;  you  can  redistribute  it and/or  modify    --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. Ocarina is distributed  in  the  hope  that it will be    --
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with Ocarina; see file COPYING.   --
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--                 Ocarina is maintained by the Ocarina team                --
--                       (ocarina-users@listes.enst.fr)                     --
--                                                                          --
------------------------------------------------------------------------------

with Types;
with Gaia.Mgmt;
with Ocarina.Printer;
with Ocarina.Analyzer;
with Ocarina.PN;
with Ocarina.Generators;
with Ocarina.Checker;

with GNAT.Dynamic_Tables;

package Ocarina_Options is

   use Types;

   package Source_File_Pkg is new GNAT.Dynamic_Tables
     (Name_Id, Nat, 1, 10, 10);

   subtype Source_File_List is Source_File_Pkg.Instance;

   type Operation is
     (Dump_Gen_Tree,
      Generate_Code,
      Expand,
      Do_Print,
      Do_Nothing,
      Petri_Net,
      Old_Petri_Net,
      Version,
      Search_Dir);

   procedure Process_Command_Line
     (Action            :    out Operation;
      Files             : in out Source_File_List;
      Gaia_Options      : in out Gaia.Mgmt.Gaia_Options;
      Generator_Options : in out Ocarina.Generators.Generator_Options;
      Analysis_Options  : in out Ocarina.Analyzer.Analyzer_Options;
      Printer_Options   : in out Ocarina.Printer.Output_Options;
      Petri_Net_Options : in out Ocarina.PN.PN_Options;
      Checker_Options   : in out Ocarina.Checker.Checker_Options;
      Parse_PPS         :    out Boolean;
      Success           :    out Boolean);
   --  Process the command line to extract the options for the
   --  different modules of Ocarina.

   procedure Usage;
   --  Display a message describing the usage of Ocarina

end Ocarina_Options;
